#include <iostream>
#include <string>
#include <string.h> // strcmp()
#include "tracer.h"
#include "utils_linefetch.h"
#include "art_defs.h"

using namespace std;

void usageexample(string appname) {
    cout << "Usage: " << appname << " --file " << "/path/to/tracefile" << endl;
    cout << "Usage: " << appname << " --sock " << "host:port" << endl;
    cout << "Usage: " << appname << " --version" << endl;
    cout << "Example: " << appname << " --file " << "tracefile.out" << endl;
    cout << "Example: " << appname << " --sock " << "localhost:12345" << endl;
}

int main(int argc, char **argv) {
    /*
    string line;
    splitted_line_t sl;
    size_t retval;

    retval = splitLine(line, &sl);
    cout << "Retval = " << retval << endl;
    dump(&sl);
    cout << "-------------------" << endl;

    line = "1word";
    retval = splitLine(line, &sl);
    cout << "Retval = " << retval << endl;
    dump(&sl);
    cout << "-------------------" << endl;

    line = "two1 words2";
    retval = splitLine(line, &sl);
    cout << "Retval = " << retval << endl;
    dump(&sl);
    cout << "-------------------" << endl;

    line = "three1 xx2 words3";
    retval = splitLine(line, &sl);
    cout << "Retval = " << retval << endl;
    dump(&sl);
    cout << "-------------------" << endl;

    line = "four1 three2 the3 words4";
    retval = splitLine(line, &sl);
    cout << "Retval = " << retval << endl;
    dump(&sl);
    cout << "-------------------" << endl;
    */

    if(1 == argc) {
        usageexample(argv[0]);
        return 0;
    }
    else if(2 == argc && (0 == strcmp(argv[1], "--version"))) {
        cout << "ART v" << ART_VERSION_BRANCH << ART_VERSION_SUB <<
                ART_VERSION_EXTRA << endl;
        return 0;
    }
    else if(3 == argc && (0 == strcmp(argv[1], "--file"))) {
        CVLineFetcher *fetcher;

        fetcher = new CFileLineFetcher;
        fetcher->attach(argv[2]); // FIXME: проверить возвращаемое значение

        return trace(fetcher);
    }
    else if(3 == argc && (0 == strcmp(argv[1], "--sock"))) {
        //CVLineFetcher *fetcher;

        //fetcher = new CSockLineFetcher();
        //fetcher.attach(argv[2]);

        //return trace(fetcher);
        return 0;
    }
    else usageexample(argv[0]);

    return 0;
}
