#include <fstream>
#include "utils_linefetch.h"

CVLineFetcher::CVLineFetcher() {}
CVLineFetcher::~CVLineFetcher() {}

///////////////////////////////////////////

CFileLineFetcher::CFileLineFetcher() {
    c_lineIsPeekedLine = false;
    lineCounter = 0;
}

int CFileLineFetcher::attach(char* file) {
    trace.open(file);

    if(!trace.good()) return -1;

    return 0;
}

int CFileLineFetcher::attach(int s) {
    (void)s;
    throw "CFileLineFetcher::attach(int s); called !!!";
}

LineCounter CFileLineFetcher::fetchLine(string &str) {
    if(c_lineIsPeekedLine) {
        str = c_line;
        c_lineIsPeekedLine = false;
        return lineCounter;
    }

    trace.getline(c_line, clinefetcher_ss);

    if (trace.eof()) {
        throw "eof";
    }

    if (!trace.good()) throw "i/o error";

    lineCounter++;

    str = c_line;

    return lineCounter;
}

void CFileLineFetcher::peekLine(string &str) {
    if(c_lineIsPeekedLine) throw "malfunction"; // см. описание CVLineFetcher::peekLine()
    fetchLine(str);
    c_lineIsPeekedLine = true;
}

//////////////////////////////////////////////////////////////////////////////
#include <string.h> // strdup()
#include <stdlib.h> // free()

// TODO: добавить возможность использования проблов так:
// слово1 "второе, да" слово3.
// TODO: неразличать несколько разделительных символов подряд.
size_t splitLine(string src, splitted_line_t *dst) {
    size_t i, src_len = src.length();
    char c;

    dst->chunk.clear();

    if(0 == src_len) return 0; // nothing to split

    vector<size_t> spacePlace;

    for(i = 0; i < src_len; i++) {
        c = src.at(i);
        if(' ' == c || '\t' == c) spacePlace.push_back(i);
    }

    size_t spaces_len = spacePlace.size();
    if(0 == spaces_len) { // src contains only one word
        string tmp_s(src);
        dst->chunk.push_back(tmp_s);
        return 1;
    }

    char *copy_of_string;
    copy_of_string = strdup(src.c_str());
    if(!copy_of_string) return 0; // no mem - no result

    for(i = 0; i < spaces_len; i++) {
        string tmp_s;
        //c = copy_of_string[spacePlace[i]];
        copy_of_string[spacePlace[i]] = 0;
        tmp_s = copy_of_string + (i == 0 ? 0 : spacePlace[i - 1] + 1);
        // copy_of_string[spacePlace[i]] = c;// восстанавливать не обязательно
        dst->chunk.push_back(tmp_s);
    }

    // добавляем последний сегмент
    string tmp_s;
    tmp_s = copy_of_string + spacePlace[spacePlace.size() - 1] + 1;
    dst->chunk.push_back(tmp_s);

    free(copy_of_string);

    return dst->chunk.size(); // а тут можно было бы возвращать i(-1?)
    //return i;
}

//#ifdef ART_DEBUG
#include <iostream>

void dump(splitted_line_t *splitted_line) {
    size_t i, l = splitted_line->chunk.size();

    cout << "Splitted line in " << l << " chunks:" << endl;
    for(i = 0; i < l; i++) {
        cout << '[' << i << "] = '" << splitted_line->chunk[i] << '\'' << endl;
    }
}
//#endif
